import {AppPage} from "./app.po";
import {
  browser,
  by,
  element,
  ElementArrayFinder,
  ElementFinder,
  protractor,
  ProtractorExpectedConditions
} from "protractor";


/**
 * unit testy pro otestovani databaye, ukladani dat a cteni
 * funkce it() spousti test
 * funkce xit() ignoruje test
 */
describe('UXtestmanagerweb testing', () => {
  const EC: ProtractorExpectedConditions = protractor.ExpectedConditions;
  const testName: string = "Testovani mobilu Lenovo";
  const instName: string = "Protractor-test";
  const testEmail: string = "dimatest01@gmail.com";

  let page: AppPage;

  beforeAll(() => {
    page = new AppPage();
    browser.waitForAngularEnabled(false);
    browser.driver.manage().window().maximize();
  });

  beforeEach(() => {
    browser.sleep(1000);
  });

  it('should log in to google', () => {
    page.navigateTo("/login");

    page.getButtonById("login").click();

    // pri prihlaseni do googlu vyskoci popup okno, to musim odchytit
    browser.getAllWindowHandles().then(function (handles) {
      var popupHandle = handles[1];
      browser.switchTo().window(popupHandle);

      page.getInputByName("identifier").sendKeys("UXtestmanagerweb.test1@gmail.com");

      page.getButtonById("identifierNext").click();

      page.getInputByName("password").sendKeys("Heslo123");

      page.getButtonById("passwordNext").click();

      browser.driver.switchTo().window(handles[0]);
    });
  });

  it('should pick and load test', () => {
    //browser.sleep(2000);
    // page.navigateTo("/");
    page.getButtonById(testName).click();

  });

  xit('should create test questionnaires and questions', async () => {
    const question = "Protractor Test Question";

    page.waitForElementWithText("testName", testName);

    // otevre questionnaire
    page.getButtonById("idTestQuest").click();

    // PRE pokud v dotazniku neco je, tak to smazu
    try {
      let delBtnPre = element(by.id("idDelPre"));
      let resultPre = await browser.wait(EC.elementToBeClickable(delBtnPre), 5000);
      if (resultPre) {
        delBtnPre.click();
      }
    } catch (er) {
      console.log("neni co mazat");
    }

    // POST pokud v dotazniku neco je, tak to smazu
    try {
      let delBtn = element(by.id("idDelPost"));
      let result = await browser.wait(EC.elementToBeClickable(delBtn), 5000);
      if (result) {
        delBtn.click();
      }
    } catch (er) {
      console.log("neni co mazat");
    }

    // PREvytvorim novy dotaznik
    page.getButtonById("idCreatePre").click();
    page.getInputByName("inputQuestPre").sendKeys(question);
    page.getButtonById("idSubmitQuestPre").click();

    // POST vytvorim novy dotaznik
    page.getButtonById("idCreatePost").click();
    page.getInputByName("inputQuestPost").sendKeys(question);
    page.getButtonById("idSubmitQuestPost").click();


    // PRE zkontroluju, jestli  se do seznamu pridala data
    let list = page.getListByCss("#questPreList li.list-group-item");
    expect(list.count()).toBeGreaterThan(0);

    // POST zkontroluju, jestli  se do seznamu pridala data
    let list = page.getListByCss("#questPostList li.list-group-item");
    expect(list.count()).toBeGreaterThan(0);
  });

  xit('should create test case and tasks', () => {
    page.waitForElementWithText("testName", testName);

    // otevre test cases
    page.getButtonById("idTestCases").click();

    page.getInputByName("inputNewCase").sendKeys("Protractor Test Case");
    page.getButtonById("idAddCase").click();

    // vezmu vytvoreny case
    let createdCase = page.getListByCss("#idListCases li.list-group-item").last();

    expect(createdCase.element(by.css(".protractor-case-name")).getText()).toEqual("Protractor Test Case");

    createdCase.click();

    // tasky jsou nactene z test cases, neni treba wait
    let tasksBefore = element.all(by.css("#idListTasks li.list-group-item")).count();
    page.getInputByName("inputNewTask").sendKeys("Protractor Task");
    page.getButtonById("idAddTask").click();
    let tasksAfter = page.getListByCss("#idListTasks li.list-group-item").count();

    expect(tasksAfter).toBeGreaterThan(tasksBefore);

  });

  xit('should create participant', () => {
    page.waitForElementWithText("testName", testName);
    // otevre participanty
    page.getButtonById("idTestParticipants").click();

    let partsBefore = 0;
    try {
      // pokud je list prazdny tak funkce wait vyhodi chybu, proto try-catch
      partsBefore = page.getListByCss("#idListParts li.list-group-item").count();
    } catch (e) {
      console.log("partsBefore.count = 0");
    }
    page.getInputByName("inputPartName").sendKeys("Protractor Participant");
    page.getButtonById("idAddPart").click();
    let partsAfter = page.getListByCss("#idListParts li.list-group-item").count();

    expect(partsAfter).toBeGreaterThan(partsBefore);
  });

  xit('should add member', async () => {
    page.waitForElementWithText("testName", testName);

    // otevre participanty
    page.getButtonById("idTestMembers").click();

    let membersBefore: ElementArrayFinder = page.getListByCss("#idListMembers li.list-group-item");
    let membersCountBefore = await membersBefore.count();

    // pokud uz je testovany email v seznamu, smazu ho
    let testItemArr = membersBefore.filter(async (el: ElementFinder, index: number) => {
      let email = await el.element(by.css(".protractor-member-name")).getText();
      return email === testEmail;
    });

    // pokud se nasel, tak ho smazu
    if (await testItemArr.count() > 0) {
      let testItem = testItemArr.first();
      testItem.element(by.className("protractor-delete")).click();
      membersCountBefore--;
    }

    page.getInputByName("inputAddMember").sendKeys(testEmail);
    page.getButtonById("idAddMember").click();

    let membersCountAfter = page.getListByCss("#idListMembers li.list-group-item").count();

    expect(membersCountAfter).toBeGreaterThan(membersCountBefore);
  });

  xit('should create marker', () => {
    page.waitForElementWithText("testName", testName);
    // otevre markery
    page.getButtonById("idTestMarkers").click();

    let markersBefore = 0;
    try {
      // pokud je list prazdny tak funkce wait vyhodi chybu, proto try-catch
      markersBefore = page.getListByCss("#idListMarkers li.list-group-item").count();
    } catch (e) {
      console.log("partsBefore.count = 0");
    }
    page.getInputByName("inputAddMarker").sendKeys("Protractor marker");
    page.getButtonById("idAddMarker").click();
    let markersAfter = page.getListByCss("#idListMarkers li.list-group-item").count();

    expect(markersAfter).toBeGreaterThan(markersBefore);
  });

  xit('should create log file and logs', async () => {
    page.waitForElementWithText("testName", testName);

    // pokud je slozka otevrena, je zobrazen seznam idListFIles
    let isFolderOpen: boolean = await element(by.id("idListFIles")).isPresent();

    if (!isFolderOpen) {
      // otevre files zalozku
      page.getButtonById("idTestFilesFolder").click();
    }

    // neni potreba wait, data uz jsou nactena
    let filesBefore = element.all(by.css("#idListFIles li")).count();
    page.getElementById("idFilesMenu").click();
    page.getButtonById("idAddLog").click();
    let filesAfter = page.getListByCss("#idListFIles li");

    expect(filesAfter.count()).toBeGreaterThan(filesBefore);

    let logFile = filesAfter.last();
    logFile.click();

    // log 1
    page.getInputByName("inputMarker").sendKeys("Usability Problem");
    page.getInputByName("inputComment").sendKeys("Protractor Usability Problem");
    page.getButtonById("idAddLog").click();

    // log 2
    page.getInputByName("inputMarker").sendKeys("Positive Opinion");
    page.getInputByName("inputComment").sendKeys("Protractor Positive Opinion");
    page.getButtonById("idAddLog").click();

    let logList = page.getListByCss("#idListLogs li.list-group-item");

    expect(logList.count()).toBe(2);

  });

  it('should create text file and edit', async () => {
    page.waitForElementWithText("testName", testName);

    // pokud je slozka otevrena, je zobrazen seznam idListFIles
    let isFolderOpen: boolean = await element(by.id("idListFIles")).isPresent();

    if (!isFolderOpen) {
      // otevre files zalozku
      page.getButtonById("idTestFilesFolder").click();
    }

    // neni potreba wait, data uz jsou nactena
    let filesBefore = element.all(by.css("#idListFIles li")).count();
    page.getElementById("idFilesMenu").click();
    page.getButtonById("idAddText").click();
    let filesAfter = page.getListByCss("#idListFIles li");

    expect(filesAfter.count()).toBeGreaterThan(filesBefore);

    let textFile = filesAfter.last();
    textFile.click();

    let textarea = page.getElementById("idTextarea");
    let newText = "Protractor Lorem ipsum...";
    page.getButtonById("idTextEdit").click();
    textarea.sendKeys(newText);
    page.getButtonById("idTextSave").click();

    expect(page.getElementById("idTextarea").getAttribute("value")).toBe(newText);

  });

  xit('should create instance', () => {

    page.getElementById("idInstFolder").click();

    let instListLenBefore = page.getListByCss("#idListInstances li").count();

    page.getElementById("idInstFolderMenu").click();
    page.getButtonById("idMenuAddInst").click();
    page.getInputByName("inputNewInst").sendKeys("Protractor-" + new Date().getTime());
    page.getButtonById("idCreateInst").click();

    let instListLenAfter = page.getListByCss("#idListInstances li").count();

    expect(instListLenAfter).toBeGreaterThan(instListLenBefore);
  });

  xit('should open and answer post-question', async () => {

    // click na nazev instance
    page.getElementByCss("#" + instName).click();

    // click na quest instance
    page.getElementByCss("#" + instName + " .protractor-quest").click();

    // PRE pokud v dotazniku neco je, tak to smazu
    try {
      let delBtnPre = element(by.id("idDelPre"));
      let resultPre = await browser.wait(EC.elementToBeClickable(delBtnPre), 5000);
      if (resultPre) {
        delBtnPre.click();
      }
    } catch (er) {
      console.log("neni co mazat");
    }

    // POST pokud v dotazniku neco je, tak to smazu
    try {
      let delBtn = element(by.id("idDelPost"));
      let result = await browser.wait(EC.elementToBeClickable(delBtn), 5000);
      if (result) {
        delBtn.click();
      }
    } catch (er) {
      console.log("neni co mazat");
    }

    // v nove instanci neni vytvoreny dotaznik, tak ho udelam
    page.getButtonById("idCreatePostInst").click();
    page.getButtonById("idCreatePreInst").click();

    // PRE
    // zkontroluju, jestli v seznamu je zaznam, ktery jsem vytvoril predtim
    let list = page.getListByCss("#idQuestListPre li");
    expect(list.count()).toBeGreaterThan(0);

    let listItem = list.first();
    listItem.element(by.css(".protractor-pre-edit")).click();
    listItem.element(by.name("inputPreAnswer")).sendKeys("Protractor Answer");
    listItem.element(by.css(".protractor-pre-save")).click();
    let answer = listItem.element(by.css(".protractor-pre-answer"));
    expect(answer.getText()).toEqual("Protractor Answer");

    // POST
    // zkontroluju, jestli v seznamu je zaznam, ktery jsem vytvoril predtim
    let list = page.getListByCss("#idQuestListPost li");
    expect(list.count()).toBeGreaterThan(0);

    let listItem = list.first();
    listItem.element(by.css(".protractor-post-edit")).click();
    listItem.element(by.name("inputPostAnswer")).sendKeys("Protractor Answer");
    listItem.element(by.css(".protractor-post-save")).click();
    let answer = listItem.element(by.css(".protractor-post-answer"));
    expect(answer.getText()).toEqual("Protractor Answer");
  });
});
