import { Observable } from "rxjs/Rx";
import { AlertComponent } from "./alert.component";

export class Alert {

    public static success: string = "success";
    public static info: string = "info";
    public static error: string = "danger";
    public static warning: string = "warning";

    public isClosing: boolean;
    public isClosed: boolean;

    private controller: AlertComponent;

    constructor(public message: string, public type: string, public isLoading: boolean, controller: AlertComponent) {
        this.controller = controller;
        if (!isLoading) {
            Observable.timer(4500).subscribe(() => {
                this.close();
            });
        }
    }

    public close(): void {
        if (this.isClosing || this.isClosed) {
            return;
        }
        this.isClosing = true;
        const element: Element = this.controller.alertsList.nativeElement.children[this.controller.alerts.indexOf(this)];
        element.classList.add("close-alert");
        Observable.timer(2000).subscribe(() => {
            this.isClosed = true;
            this.controller.alerts.splice(this.controller.alerts.indexOf(this), 1);
        });
    }
}
