import {Component, OnInit} from "@angular/core";
import {AngularfireService} from "../services/angularfire.service";
import {UserService} from "../services/user.service";
import {Router} from "@angular/router";
import {AngularFireAuth} from "angularfire2/auth";
import {verze} from "./app.module";

@Component({
  selector: "app-root",
  templateUrl: "./app.component.html",
  styleUrls: ["./app.component.css"]
})
export class AppComponent {

  title = "app";
  private config: any;
  private layout: any;
  public isLoggedIn: boolean;
  public verze: string = verze;

  constructor(private afService: AngularfireService,
              private afAuth: AngularFireAuth,
              private userSvc: UserService,
              private router: Router) {

    // pokud uzivatel neni prihlaseny na googlu, presmeruje ho aplikace na login
    console.log("start");
    this.afAuth.authState.subscribe(
      (auth) => {
        if (auth == null) {
          console.log("Not Logged in.");
          this.router.navigate(["login"]);
          this.isLoggedIn = false;
        } else {
          console.log("Successfully Logged in.");
          this.isLoggedIn = true;
          this.userSvc.setUser({
            email: auth.email,
            name: auth.displayName,
            uid: auth.uid
          });
          this.router.navigate([""]);
        }
      }
    );
  }

  public logout(): void {
    this.afService.logout();
  }
}

