import { Injectable } from "@angular/core";
import { BsModalService } from 'ngx-bootstrap/modal';
import { BsModalRef } from 'ngx-bootstrap/modal/bs-modal-ref.service';
import {ConfirmComponent} from "./confirm.component";
import {Locale} from "../../constants/Locale";

@Injectable()
export class ConfirmController {

    public locale: any = Locale.getLocale();
    constructor(private bsModalSvc: BsModalService) { }

    public show(message: string, title: string = "", okButton: string = this.locale.ok, cancelButton: string = this.locale.cancel): Promise<boolean> {
        return new Promise<boolean>((resolve: any) => {
            const bSModalRef: BsModalRef = this.bsModalSvc.show(ConfirmComponent, {
                class: "modal-sm",
                backdrop: "static",
                ignoreBackdropClick: true
            });

            bSModalRef.content.resolveFunction = resolve;

            bSModalRef.content.message = message;
            bSModalRef.content.title = title;
            bSModalRef.content.okButton = okButton;
            bSModalRef.content.cancelButton = cancelButton;
        });
    }

}
