import {Component} from "@angular/core";
import {AngularfireService} from "../../services/angularfire.service";
import {Router} from "@angular/router";

@Component({
  selector: "app-login-page",
  templateUrl: "./login.component.html",
  styleUrls: ["./login.component.css"]
})
export class LoginComponent {
  constructor(private afService: AngularfireService) {
  }

  /**
   * login pres google ucet
   * @returns {Promise<void>}
   */
  public async login(): Promise<void> {
    try {
      await this.afService.loginWithGoogle();
    } catch (error) {
      console.log(error);
      alert("S timto uctem se nelze prihlasit");
    }
  }
}

