import {Component, OnDestroy, OnInit} from "@angular/core";
import {AngularfireService} from "../../services/angularfire.service";

@Component({
  selector: "app-participants",
  templateUrl: "./participants.component.html",
  styleUrls: ["./participants.component.css"]
})
export class ParticipantsComponent implements OnInit, OnDestroy {

  public participants: Array<any> = [];
  public testId: string;
  public data: any;
  private subscriptions: Array<any> = [];

  constructor(private afService: AngularfireService) {
  }

  ngOnInit() {
    console.log(this.data);
    if (!this.data) {
      return;
    }

    const sub = this.afService.getTestParticipants(this.data.testId).subscribe((parts: any) => {
      this.participants = parts;
    });
    this.subscriptions.push(sub);

  }

  public add(input): void {
    this.afService.addParticipant(this.testId, input.value).then(() => {
      input.value = "";
    });
  }

  public edit(participant: any): void {
    participant.editing = true;
    participant.nameNew = participant.name;
  }

  public save(participant: any): void {
    this.afService.editParticipant(this.testId, participant.id, participant.nameNew);
  }

  public close(participant: any): void {
    participant.editing = false;
  }

  public delete(participant: any): void {
    this.afService.delParticipant(this.testId, participant.id);
  }

  ngOnDestroy(): void {
    try {
      this.subscriptions.forEach(sub => {
        sub.unsubscribe();
      });
    } catch (e) {
      console.log(e);
    }
  }
}
