import {Component, OnDestroy, OnInit} from "@angular/core";
import {AngularfireService} from "../../services/angularfire.service";

@Component({
  selector: "app-test-cases-inst",
  templateUrl: "./test-cases-inst.component.html",
  styleUrls: ["./test-cases-inst.component.css"]
})
export class TestCasesInstComponent implements OnInit, OnDestroy {

  public data: any;
  public selectedCaseTasks: Array<any>;
  public selectedCase: any;
  public isSelecting = false;
  public cases: Array<any> = [];
  private subscriptions: Array<any> = [];

  constructor(private afService: AngularfireService) {
  }

  ngOnInit() {
    if (!this.data) {
      return;
    }

    // ziskani test case instance (jedna, ne seznam vsech)
    const sub = this.afService.getInstTestCase(this.data.testId, this.data.instId).subscribe((tc: any) => {
      if (!tc) {
        return;
      }
      this.selectedCase = tc;
      const sub2 = this.afService.getAbstractDataList(tc.id).subscribe((casse: any) => {
        if (casse) {
          this.selectedCaseTasks = casse;
        }
      });
      this.subscriptions.push(sub2);
    });
    this.subscriptions.push(sub);
  }

  /**
   * chci vubrat test case, tato funkce stahne seznam test case zadanych v testu
   */
  public selectTestCase(): void {
    this.isSelecting = true;
    const sub = this.afService.getTestTestCases(this.data.testId).subscribe((testCases: any) => {
      this.cases = testCases;
    });
    this.subscriptions.push(sub);
  }

  /**
   * vybrani test case do instance
   * @param testCase ktery resi instance
   */
  public setTestCase(testCase: any): void {
    const sub2 = this.afService.setInstTestCase(this.data.testId, this.data.instId, testCase).then(() => {
      this.isSelecting = false;
    });
    this.subscriptions.push(sub2);
  }

  ngOnDestroy(): void {
    try {
      this.subscriptions.forEach(sub => {
        sub.unsubscribe();
      });
    } catch (e) {
      console.log(e);
    }
  }
}
