export class Locale {

  private static lang: string = "en";

  private static locale: any = {
    cs: {
      alertVideoIsIn: "Video už je přidané",
      noUserId: "Uživatel není přihlášený",
      delete: "Smazat souboru",
      deleteSure: "Jste si jisti, že chcete smazat soubor ",
      rename: "Přejmenovat ",
      save: "Uložit",
      ok: "Ok",
      cancel: "Zrušit",
      renameFail: "Nepodařilo se přejmenovat soubor",
      updateFail: "Nepodařilo se změnit soubor",
      updateOk: "Text upraven",
      renameOk: "Soubor přejmenován",
      deleteOk: "Soubor smazán",
      fileNotFound: "Soubor nenalezen",
      fit: "Přizpůsobit časovou osu.",
      start: "Začátek testu",
      end: "Konec testu",
      stop: "Zastavit",
      play: "Přehrát",
      pause: "Pozastavit",
      forward5: "Posunout o 5s",
      replay5: "Vrátit o 5s",
      faster: "Rychleji",
      slower: "Pomaleji",
      speed: "Rychlost přehrávání",
      time: "Čas",
      close: "Zavřít",
      zoomIn: "Zvětšit",
      zoomOut: "Zmenšit",
      files: "Soubory",
      instances: "Instance",
      quest: "Dotazníky",
      testCases: "Případy užití",
      testCase: "Případ užití",
      participants: "Participanti",
      members: "Členové",
      markers: "Markery",
      info: "Informace",
      fitItemTl: "Najít na ose",
      mute: "Hlasitost",
      newInst: "Nová instance",
      allFiles: "Všechny sobory"
    },
    en: {
      alertVideoIsIn: "Video already loaded",
      noUserId: "User is logged out",
      delete: "Delete file",
      deleteSure: "Are you sure you want to delete ",
      rename: "Rename ",
      save: "Save",
      ok: "Ok",
      cancel: "Cancel",
      renameFail: "Rename failed",
      updateFail: "Update failed",
      updateOk: "Text updated",
      renameOk: "Renamed",
      deleteOk: "File deleted",
      fileNotFound: "File not found",
      fit: "Fit Timeline",
      stop: "Stop",
      start: "Start of the test",
      end: "End of the test",
      play: "Play",
      pause: "Pause",
      forward5: "Forward 5s",
      replay5: "Replay 5s",
      faster: "Faster",
      slower: "Slower",
      speed: "Speed",
      time: "Time",
      close: "Close",
      zoomIn: "Zoom in",
      zoomOut: "Zoom out",
      files: "Files",
      instances: "Instances",
      quest: "Questionnaires",
      testCases: "Test Cases",
      testCase: "Test Case",
      participants: "Participants",
      members: "Members",
      markers: "Markers",
      info: "Information",
      fitItemTl: "Find on timline",
      mute: "Volume",
      newInst: "New Instance",
      allFiles: "All Files"
    }
  };

  public static getLocale(): any {
    return this.locale[this.lang];
  }

  public static setLang(lang: string): void {
    this.lang = lang;
  }

  public static getLang(): string {
    return this.lang;
  }
}
