import {Injectable} from "@angular/core";
import {User} from "../model/User";
import {AngularfireService} from "./angularfire.service";

@Injectable()
export class UserService {

  public user: User;

  constructor(private afService: AngularfireService) {
  }

  public async setUser(user: User): Promise<void> {
    this.user = user;
    this.afService.userId = user.uid;
    localStorage.setItem("user", JSON.stringify(user));
    // this.storage.set("user", user);
  }

  public getUser(): User {
    if (this.user !== undefined) {
      return this.user;
    }
    this.user = JSON.parse(localStorage.getItem("user"));
    return this.user;
  }
}
