import {Injectable} from "@angular/core";
import {Subject} from "rxjs/Subject";
import {Observable} from "rxjs/Observable";

@Injectable()
export class VideoService {
  public videoOffset: number = 0;
  private videoReadySubject: Subject<any> = new Subject<any>();
  private videoSubject: Subject<any> = new Subject<any>();
  private timelineTime: Subject<any> = new Subject<any>();
  private findItemInTimeline: Subject<any> = new Subject<any>();
  private currentTime: number = new Date().getTime();

  constructor() {
    this.getTimelineSub().subscribe((data: any) => {
      this.currentTime = data.time;
    });
  }

  public getCurrentTime(): number {
    return this.currentTime;
  }

  public getTimelineSub(): Observable<any> {
    return this.timelineTime.asObservable();
  }

  public getTimelineSubAsVar(): any {
    return this.timelineTime;
  }
  public getFindItemInTimeline(): any {
    return this.findItemInTimeline;
  }
  public getVideoSub(): Observable<any> {
    return this.videoSubject.asObservable();
  }

  public getVideoSubAsVar(): any {
    return this.videoSubject;
  }
  public getVideoReadySub(): Observable<any> {
    return this.videoReadySubject.asObservable();
  }

  public getVideoReadySubAsVar(): any {
    return this.videoReadySubject;
  }
}
